#include "HelloWorldScene.h"

#include "VisibleRect.h"

USING_NS_CC;

CCScene* HelloWorld::scene()
{
	// 'scene' is an autorelease object
	CCScene *scene = CCScene::node();
	
	// 'layer' is an autorelease object
	HelloWorld *layer = HelloWorld::node();

	// add layer as a child to scene
	scene->addChild(layer);

	// return the scene
	return scene;
}

// on "init" you need to initialize your instance
bool HelloWorld::init()
{
	//////////////////////////////
	// 1. super init first
	if ( ! CCLayer::init() )
	{
		return false;
	}

	// add background image
	CCSprite* pSprite = CCSprite::spriteWithFile("HelloWorld.png");
    CCPoint pos = VisibleRect::center();
	pSprite->setPosition( pos );
    this->addChild(pSprite, 0);

    // add some UI items
    CCSprite* pUiItem = 0;
    pUiItem = CCSprite::spriteWithFile("CloseNormal.png");  // life
    pos = VisibleRect::top();
    pos.x -= 100;
    pUiItem->setPosition(pos);
    pUiItem->setAnchorPoint(ccp(0.5, 1));
    this->addChild(pUiItem);

    pUiItem = CCSprite::spriteWithFile("CloseNormal.png");  // mana
    pos = VisibleRect::top();
    pos.x += 100;
    pUiItem->setPosition(pos);
    pUiItem->setAnchorPoint(ccp(0.5, 1));
    this->addChild(pUiItem);

    pUiItem = CCSprite::spriteWithFile("CloseNormal.png");  // portrait
    pos = VisibleRect::bottom();
    pUiItem->setPosition(pos);
    pUiItem->setAnchorPoint(ccp(0.5, 0));
    this->addChild(pUiItem);
	
    pUiItem = CCSprite::spriteWithFile("CloseNormal.png");  // control
    pos = VisibleRect::bottomLeft();
    pos.x += 32;
    pos.y += 32;
    pUiItem->setPosition(pos);
    pUiItem->setAnchorPoint(ccp(0, 0));
    this->addChild(pUiItem);

    pUiItem = CCSprite::spriteWithFile("CloseNormal.png");  // attack
    pos = VisibleRect::bottomRight();
    pos.x -= 32;
    pos.y += 32;
    pUiItem->setPosition(pos);
    pUiItem->setAnchorPoint(ccp(1, 0));
    this->addChild(pUiItem);

    // add a exit button in the top right conner to exit the progress
    CCMenuItemImage *pCloseItem = CCMenuItemImage::itemFromNormalImage(
        "CloseNormal.png",
        "CloseSelected.png",
        this,
        menu_selector(HelloWorld::menuCloseCallback) );
    pos = VisibleRect::topRight();
    pCloseItem->setPosition( pos );
    pCloseItem->setAnchorPoint(ccp(1, 1));

    // create menu, it's an autorelease object
    CCMenu* pMenu = CCMenu::menuWithItems(pCloseItem, NULL);
    pMenu->setPosition( CCPointZero );
    this->addChild(pMenu, 1);

    this->setPosition(CCPointZero);
	return true;
}

void HelloWorld::menuCloseCallback(CCObject* pSender)
{
	CCDirector::sharedDirector()->end();

#if (CC_TARGET_PLATFORM == CC_PLATFORM_IOS)
	exit(0);
#endif
}
