#include "VisibleRect.h"

using namespace cocos2d;

const CCRect&  VisibleRect::rect()
{
    static CCRect s_rcVisible;
    if (0 == s_rcVisible.size.width)
    {
        CCEGLView::sharedOpenGLView().getScreenRectInView(s_rcVisible);
    }

    return s_rcVisible;
}

const CCPoint& VisibleRect::center()
{
    static CCPoint s_ptCenter;
    if (0 == s_ptCenter.x)
    {
        CCRect rc = VisibleRect::rect();
        s_ptCenter.x = rc.origin.x + rc.size.width / 2;
        s_ptCenter.y = rc.origin.y + rc.size.height / 2;
    }
    return s_ptCenter;
}

const CCPoint& VisibleRect::top()
{
    static CCPoint s_ptTop;
    if (0 == s_ptTop.x)
    {
        CCRect rc = VisibleRect::rect();
        s_ptTop.x = rc.origin.x + rc.size.width / 2;
        s_ptTop.y = rc.origin.y + rc.size.height;
    }
    return s_ptTop;
}

const CCPoint& VisibleRect::topRight()
{
    static CCPoint s_ptTopRight;
    if (0 == s_ptTopRight.x)
    {
        CCRect rc = VisibleRect::rect();
        s_ptTopRight.x = rc.origin.x + rc.size.width;
        s_ptTopRight.y = rc.origin.y + rc.size.height;
    }
    return s_ptTopRight;
}

const CCPoint& VisibleRect::right()
{
    static CCPoint s_ptRight;
    if (0 == s_ptRight.x)
    {
        CCRect rc = VisibleRect::rect();
        s_ptRight.x = rc.origin.x + rc.size.width;
        s_ptRight.y = rc.origin.y + rc.size.height / 2;
    }
    return s_ptRight;
}

const CCPoint& VisibleRect::bottomRight()
{
    static CCPoint s_ptBottomRight;
    if (0 == s_ptBottomRight.x)
    {
        CCRect rc = VisibleRect::rect();
        s_ptBottomRight.x = rc.origin.x + rc.size.width;
        s_ptBottomRight.y = rc.origin.y;
    }
    return s_ptBottomRight;
}

const CCPoint& VisibleRect::bottom()
{
    static CCPoint s_ptBottom;
    if (0 == s_ptBottom.x)
    {
        CCRect rc = VisibleRect::rect();
        s_ptBottom.x = rc.origin.x + rc.size.width / 2;
        s_ptBottom.y = rc.origin.y;
    }
    return s_ptBottom;
}

const CCPoint& VisibleRect::bottomLeft()
{
    return VisibleRect::rect().origin;
}

const CCPoint& VisibleRect::left()
{
    static CCPoint s_ptLeft;
    if (0 == s_ptLeft.x)
    {
        CCRect rc = VisibleRect::rect();
        s_ptLeft.x = rc.origin.x;
        s_ptLeft.y = rc.origin.y + rc.size.height / 2;
    }
    return s_ptLeft;
}

const CCPoint& VisibleRect::topLeft()
{
    static CCPoint s_ptTopLeft;
    if (0 == s_ptTopLeft.x)
    {
        CCRect rc = VisibleRect::rect();
        s_ptTopLeft.x = rc.origin.x;
        s_ptTopLeft.y = rc.origin.y + rc.size.height;
    }
    return s_ptTopLeft;
}
